c Copyright (c) 2013, Dr Renato Vacondio, Dr Benedict Rogers, Prof. Peter Stansby 
c and Prof. Paolo Mignosa
c 
c All rights reserved.
c 
c This file is part of SWE-SPHYSICS.
c 
c Redistribution and use in source and binary forms, with or without modification, 
c are permitted provided that the following conditions are met:
c 
c - Redistributions of source code must retain the above copyright notice, 
c  this list of conditions and the following disclaimer.
c - Redistributions in binary form must reproduce the above copyright notice, 
c  this list of conditions and the following disclaimer in the documentation 
c  and/or other materials provided with the distribution.
c
c THE "SWE-SPHYSICS" IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
c ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
c OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
c THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
c SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
c OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
c HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR 
c TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
c EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

       program sph
       
       use global_1D
       
       character supp*4,name*40,detsupp*4

       integer i 

       real dummy, grz, g
              
       REAL time_begin, time_end
       CALL CPU_TIME (time_begin)
       
       print*
       write(*,*) '<SWE-SPHYSICS>  Copyright (C) <2013>'
       write(*,*) 
     & '<Dr Renato Vacondio, Dr Benedict Rogers, '
       write(*,*) 
     & 'Prof. Peter Stansby and Prof. Paolo Mignosa, '
       write(*,*) 'This program comes with ABSOLUTELY NO WARRANTY;    '
       write(*,*) 'This is free software, and you are welcome to      '
       write(*,*) 'redistribute it under conditions stated in         '
       write(*,*) 'the FreeBSD License;                                   '

       print*
       print*,' ---       SPHYSICS_SWE_1D.F       ---'
       print*,' ---       Distributed under       ---'
       print*,' ---      the FreeBSD License      ---'
       print*
       
c
c  ...  constants
c       

       pi=4.*atan(1.)
       g=9.81
       dm=1 !number of dimension (1 in 1d 2 in 2d)

c
c ... kernel constants (just for kubic kernel)
c
       const_ker(1)=1./6. 
       const_ker(2)=2./3.

c
c  ...  initialization
c 
       grz=-g
       grav=g
          
       call getdata

       open(18,file='matlabin')

       write(18,*) np
       write(18,*) vlx
       write(18,*) out

       close(18)

! link - list of bottom particles       
       if (np_b.gt.0) then
          call divide_b
!bottom interpolation 
          call bottom
      endif

! RV 16/05/10 dw is the water elevation it is transformed in the actual water depth just here
      do i=1,np
         dw(i)=dw(i)-h_t(i)
         if (dw(i).lt.0) then
             write(*,*) 'negative water depth is calculated at part. # '
     + ,i, 'check the initial condition in the SPHYSICS_SWE_gen'
         STOP
         end if
	 cs(i)=sqrt(dw(i)*grav)
	 pm(i)=rho0*dw(i)*areap(i)
         rhop(i)=rho0*dw(i)
         dw0(i)=dw(i)
      enddo

      if(i_restartRun.eq.1) then
	   open(19,file='dt',status='old',position='append')
      else
	   open(19,file='dt',status='replace')  
      endif
	 write(19,*) 'time dt1 dt2 dt_new'

c
c  --- write initial conditions in file PART_0001
c  
       name='PART_0001'
       write(*,*) name
       open(23,file=name)
       call poute(23) 
       close(23)

      np=np_fixed
      call check_limits_1D	
      call ghost !ghost particles for bc
      call ini_divide(2) 
      call divide(nbp1,np,2)
      call ini_divide(3)	
      call divide_ob(1,np_ob,3)

      do i=1,np
         uo(i)=up(i) !inizialize velocity at n-1/2
      enddo
       
      call open_bc(1,np_ob,dummy)
      call ac_dw !computing rhop, dw, h_var, alphap

	        
c
c  .............................. MAIN LOOP ...................................
c

       grab_P=0
       ngrab=1

              
       do while (time.lt.tmax) !1
           	         
         !-- Call Main Subroutines --  
         call step
                   
         !-- File Output Routines --
         if(grab_P.ge.out) then !2
           
           if (time.ge.trec_ini) then
               ngrab=ngrab+1
               write(supp,'(i4.4)') ngrab
               name='PART_'//supp
               write(*,*) name
               open(23,file=name)
               call poute(23)
               close(23)

	       open(44,file='restart',status='replace')
               write(44,100) itime,time,ngrab
	       close(44)
           endif

100   format(i8,e16.8,i8)
       
           grab_P=0.
       
         endif !2

         itime = itime+1
         time = time + dt
              
         write(*,*) 'time, dt  ',time,dt,'  ok'
 
         grab_P=grab_P+dt

       enddo !1                                       
       
       close(19) !dt file
       
       write(*,*) 'End '
           
       CALL CPU_TIME ( time_end )
       write(*,*)'time_begin',time_begin,'seconds'
       write(*,*)'time_end',time_end,'seconds'
       write(*,*)'Time of operation was',time_end - time_begin,'seconds'
       
       
       end       !end main program
       
