c Copyright (c) 2013, Dr Renato Vacondio, Dr Benedict Rogers, Prof. Peter Stansby 
c and Prof. Paolo Mignosa
c 
c All rights reserved.
c 
c This file is part of SWE-SPHYSICS.
c 
c Redistribution and use in source and binary forms, with or without modification, 
c are permitted provided that the following conditions are met:
c 
c - Redistributions of source code must retain the above copyright notice, 
c  this list of conditions and the following disclaimer.
c - Redistributions in binary form must reproduce the above copyright notice, 
c  this list of conditions and the following disclaimer in the documentation 
c  and/or other materials provided with the distribution.
c
c THE "SWE-SPHYSICS" IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
c ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
c OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
c THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
c SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
c OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
c HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR 
c TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
c EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


      subroutine getdata

      use global_1D

      character supp_ini*4,name_ini*40

      integer i, j, k, kk
      real coef

       open(11,file='indat')
   
       read(11,*) itest
       read(11,*) rho0
       read(11,*) viscos_val
       read(11,*) coef
       read(11,*) vlx
       read(11,*) np
       read(11,*) np_b
       read(11,*) tol
       read(11,*) ivar_dt
       read(11,*) dt
       read(11,*) CFL
       read(11,*) tmax
       read(11,*) out
       read(11,*) trec_ini
       read(11,*) i_restartRun  
       read(11,*) dxb
       read(11,*) hsm_b
       read(11,*) if_openbc
       read(11,*) idebug
       read(11,*) iMUSCL
       read(11,*) i_dw_iter
       read(11,*) i_max_iter

       close(11)
       
       write(*,*) 'itest=',itest
       write(*,*) 'rho0=',rho0
       write(*,*) 'viscos_val=',viscos_val
       write(*,*) 'coef=', coef
       write(*,*) 'vlx=',vlx
       write(*,*) 'np=',np
       write(*,*) 'np_b=',np_b
       write(*,*) 'tol=',tol
       write(*,*) 'ivar_dt=',ivar_dt
       write(*,*) 'dt=',dt
       write(*,*) 'CFL=',CFL
       write(*,*) 'tmax=',tmax
       write(*,*) 'out=',out
       write(*,*) 'trec_ini=',trec_ini
       write(*,*) 'i_restartRun=',i_restartRun
       write(*,*) 'dxb=',dxb
       write(*,*) 'hsm_b=',hsm_b
       write(*,*) 'if_openbc=',if_openbc
       write(*,*) 'idebug=', idebug
       write(*,*) 'iMUSCL=',iMUSCL
       write(*,*) 'i_dw_iter=',i_dw_iter
       write(*,*) 'i_max_iter=',i_max_iter

      !RV introduced for ghost partiles
      np_fixed=np
      nbp1=nb+1
      dt_max=dt

    
       if (np .ge. npar ) then
         write(*,*) 'Number of particles exceeds npar in common!'
         stop
       endif
       if (nb .ge. nb_max ) then
         write(*,*) 'Number of Boundary particles exceeds'
         write(*,*) 'nb_max in common!'
         stop
       endif

C     Initial image to RUN
     
      if(i_restartRun.eq.1) then

         open(44,file='RESTART')
         read(44,100)itime,time,ngrab
         close(44)

100   format(i8,e16.8,i8)

         write(supp_ini,'(i4.4)') ngrab
         name_ini='PART_'//supp_ini
         write(*,*) name_ini


       else
         itime = 0
         ngrab = 0
         grab_P = 0.0
         name_ini='ipart'

       endif
       print*,'i_restartRun ',i_restartRun 
       write(*,*)'Reading in ', name_ini


c     --- Load Fluid Particle Position Data ---  
       hmax=0
       open(13,file=name_ini)
       do i=1,np
           read(13,*) xp(i),up(i),dw(i),areap(i) !nb: dw(i) is here the water surface elevation and not the water depth
     
           h_var(i)=coef*areap(i)
           if ( hmax.lt.h_var(i) ) hmax=h_var(i)
           h_var0(i)=h_var(i)
           iflag(i)=1
       
       enddo
       close(13)
    
c     --- End Load Particle Position Data --- 

c     --- Load bottom particle Position Data ---
       xmaxb=1.E-10
       xminb=1.E+10
       if (np_b.gt.0) then
           open(14,file='ibottom')
           do i=1,np_b
              read(14,*) j,xb(i),hb(i)      
              if(xb(i).gt.xmaxb) xmaxb=xb(i)
              if(xb(i).lt.xminb) xminb=xb(i) 
           enddo
           close(14)
       
           xmaxb = xmaxb + 0.1*hsm_b
           xminb = xminb - 0.1*hsm_b
       else !no bottom particles
            xmaxb=xmax
            xminb=xmin
       endif
       ncx_b = int( (xmaxb-xminb)/(2*hsm_b) ) + 1
       nct_b = ncx_b

c     --- End load bottom particle Position Data ---
       write(*,*)' All ',np,' initial points read successfully'
       write(*,*) 'initial hmax =', hmax

       one_over_2hmax=1/(2*hmax)
     
       nstart=1     
       pi = 4.d0*datan(1.d0)
       twopi=2.*pi
       
c ---  Load openbc data ---   
       if (if_openbc.ne.0) then
       open(15,file='ibc')
       k=0
       kk=0
       do i=1,2

          read(15,*) xpbc(i), pmbc(i), h_varbc(i), iflagbc(i), 
     +      dwbc(i), upbc(i), verbc(i),dw0bc(i),dxobc(i)
     
          do j=1,2 !< it generates coordinates of open bc particles
             
             k=k+1
             xp_ob(k)=xpbc(i)-(j-1)*dxobc(i)*verbc(i)
             pm_ob(k)=pmbc(i)
             h_var_ob(k)=h_varbc(i)
             iflag_ob(k)=iflagbc(i)
             h_var0_ob(k)=h_varbc(i)/2.
             dw0_ob(k)=dw0bc(i)
             
          !   if (j.eq.1) then
                 kk=k
          !   endif 
                 ib(k)=kk
          enddo

       enddo
       
       np_ob=k
       write(*,*) 'getdata.f np_ob=', np_ob
       
       close(15)
       
       else
       
       np_ob=0
         
       endif
       
c ---  END OF Load openbc data ---  
      		 
c
c ,,,, viscosity term eta2
c
       eta  = 0.1*hmax
       eta2 = eta*eta
       
c
c  ... determine xmin,xmax

       xmin = xp(1)
       xmax = xp(1)
      
       do i=2,np
         if(xp(i).gt.xmax) xmax=xp(i)
         if(xp(i).lt.xmin) xmin=xp(i)
       enddo

       !- Limits of domain -    
       xmax_container = vlx
       xmin_container = 0

       !modified for ghost particles
       xlim_left=0
       xlim_right=vlx
       xmin=xlim_left-2*hmax
       xmax=xlim_right+2*hmax

       write(*,*)'xmin_container, xmax_container = ',
     &            xmin_container,xmax_container
       print*
       
       do i=nbp1,np
         if(xp(i).gt.xmax) xmax=xp(i)
         if(xp(i).lt.xmin) xmin=xp(i)
       enddo
       
c      -- Add small border region to prevent error --
c      -- when calculating icell.. in divide       --
       xmax = xmax + 0.1*hmax
       xmin = xmin - 0.1*hmax
       xmax_ob = xmax
       xmin_ob = xmin

       ! To place particles in a convenient place that leave the domain
       xtrash=2.*xmax
       
       ncx = int( (xmax-xmin)*one_over_2hmax ) + 1 
       nct = ncx
       
       if(nct .ge. nct_max) then
         print*
         print*,'ERROR in getdata.f'
         print*,'No. of cells exceeds nct_max in common.2D'
         print*,'nct ',nct
         print*,'nct_max   ',nct_max
         print*
         stop
       endif 
       
       write(*,*)'xmin, xmax = ',xmin,xmax
       write(*,*)'nct= ',nct
        
       return
       end
       
c     ___________________
