c Copyright (c) 2013, Dr Renato Vacondio, Dr Benedict Rogers, Prof. Peter Stansby 
c and Prof. Paolo Mignosa
c 
c All rights reserved.
c 
c This file is part of SWE-SPHYSICS.
c 
c Redistribution and use in source and binary forms, with or without modification, 
c are permitted provided that the following conditions are met:
c 
c - Redistributions of source code must retain the above copyright notice, 
c  this list of conditions and the following disclaimer.
c - Redistributions in binary form must reproduce the above copyright notice, 
c  this list of conditions and the following disclaimer in the documentation 
c  and/or other materials provided with the distribution.
c
c THE "SWE-SPHYSICS" IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
c ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
c OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
c THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
c SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
c OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
c HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR 
c TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
c EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!     introduce a set of ghost partiles      

      subroutine ghost
      use global_1D

      integer i, kk

      kk=np_fixed

      do i=1,np_fixed
         if (if_openbc.ne.1 .and. if_openbc.ne.3) then
!particle to mirror - left
             if ((xp(i) .ge. xlim_left) .and. (xp(i).le.
     $        (xlim_left+4.1*hmax))) then
                  kk=kk+1
                  iflag(kk)=1
                  xp(kk)=2*xlim_left-xp(i)
                  up(kk)=-up(i)
                  dw(kk)=dw(i)
                  cs(kk)=sqrt(abs(dw(kk))*grav)
                  pm(kk)=pm(i)
                  h_var(kk)=h_var(i)
                  rhop(kk)=rhop(i)
                  alphap(kk)=alphap(i)
                  h_t(kk)=h_t(i)
                  ighost(kk)=i !index of original particles
             endif
          endif
          if (if_openbc.ne.2 .and. if_openbc.ne.3) then
!particle to mirror - right
             if ((xp(i) .le. xlim_right) .and.
     $        (xp(i).ge.(xlim_right-4.1*hmax))) then
                  kk=kk+1
                  iflag(kk)=1
                  xp(kk)=2*xlim_right-xp(i)
                  up(kk)=-up(i)
                  dw(kk)=dw(i)
                  cs(kk)=sqrt(abs(dw(kk))*grav)
                  pm(kk)=pm(i)
                  h_var(kk)=h_var(i)
                  rhop(kk)=rhop(i)
                  alphap(kk)=alphap(i)
                  h_t(kk)=h_t(i)
                  ighost(kk)=i !index of original particles
             endif
         endif
      enddo
     
      np=kk

      return

      end

