c Copyright (c) 2013, Dr Renato Vacondio, Dr Benedict Rogers, Prof. Peter Stansby 
c and Prof. Paolo Mignosa
c 
c All rights reserved.
c 
c This file is part of SWE-SPHYSICS.
c 
c Redistribution and use in source and binary forms, with or without modification, 
c are permitted provided that the following conditions are met:
c 
c - Redistributions of source code must retain the above copyright notice, 
c  this list of conditions and the following disclaimer.
c - Redistributions in binary form must reproduce the above copyright notice, 
c  this list of conditions and the following disclaimer in the documentation 
c  and/or other materials provided with the distribution.
c
c THE "SWE-SPHYSICS" IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
c ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
c OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
c THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
c SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
c OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
c HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR 
c TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
c EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


c
c balsara non-iterative riemann solver Cha and Whitworth Mon. Not. Astron. Soc. 340, 73-90 (2003)
c
      
      subroutine balsara(p_ast,d_l,d_r,v_l,v_r,c_l,c_r)
      
      real p_ast,d_l,d_r,v_l,v_r,c_l,c_r
      real d0, g_l, g_r, d_ast

!-------------------------
!two-shock riemann solver
!------------------------- 

        
        d0=(1/9.806)*( 0.5*(c_l+c_r)+0.25*(v_r-v_l)  )**2 !eq. (10.18)
               
        g_l=sqrt( 0.5*9.806*(d0+d_l)/(d0*d_l) )
        
        g_r=sqrt( 0.5*9.806*(d0+d_r)/(d0*d_r) )
        
        d_ast=(g_l*d_l+g_r*d_r+v_r-v_l)/(g_l+g_r)
         
        p_ast=0.5*9806*d_ast*d_ast
        
        return
      
      end 
