c Copyright (c) 2013, Dr Renato Vacondio, Dr Benedict Rogers, Prof. Peter Stansby 
c and Prof. Paolo Mignosa
c 
c All rights reserved.
c 
c This file is part of SWE-SPHYSICS.
c 
c Redistribution and use in source and binary forms, with or without modification, 
c are permitted provided that the following conditions are met:
c 
c - Redistributions of source code must retain the above copyright notice, 
c  this list of conditions and the following disclaimer.
c - Redistributions in binary form must reproduce the above copyright notice, 
c  this list of conditions and the following disclaimer in the documentation 
c  and/or other materials provided with the distribution.
c
c THE "SWE-SPHYSICS" IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
c ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
c OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
c THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
c SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
c OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
c HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR 
c TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
c EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

c --- PURPOSE ---
c     calculating the slope source term (Rodriguez-Paz & Bonet C.S. 2005)

      subroutine source_slope

      use global_1D

      integer i
      real tn1, tn2, dn

      if (np_b.gt.0) then
          call ac_b !computing dh_SPH, ddh_SPH with correction 
      endif
      
      do i=1,np_fixed
   
c --- SPH evaluation of slope source term                    

        tn1=up(i)*ddH_SPH(i)*up(i)
        tn2=+ax(i)*dH_SPH(i)
         
        dn= 1 + dH_SPH(i)*dH_SPH(i)
         
        t_st(i)=+( (grav+tn1+tn2)/dn )*dH_SPH(i)
c       t_st(i)=+ grav*dH_SPH(i)

        ! calculating the acceleration with the source term
        udot(i)=ax(i)-t_st(i)
          
      enddo
     
      
      end
